---
title: Using light sensors
slug: Web/API/DeviceLightEvent/Using_light_sensors
tags:
  - API
  - DeviceLightEvent
  - Guide
  - HTML5
  - JavaScript
---
<p>{{APIRef("Ambient Light Events")}}{{SeeCompatTable}}</p>

<p><strong>Ambient Light Events</strong> give a web application access to a device's ambient light sensor to detect changes in light intensity. </p>

<h2 id="How_Does_it_Work"><span style="line-height: 1.572;">How Does it Work?</span></h2>

<p>When the light sensor of the device detects a change in light intensity, the browser is notified of the change and fires a {{DOMxRef("DeviceLightEvent")}} event.  The event gives information about the light intensity of the device's environment.</p>

<p>The {{DOMxRef("DeviceLightEvent")}} provides a value attribute with light intensity in <em>lux</em> which is generally treated as shown below.</p>

<div class="note">
<p>10 ~ 50 lux : Dim Environment</p>

<p>100 ~ 1000 lux : Normal</p>

<p>&gt; 10000 lux : Bright</p>
</div>

<p>It uses the {{DOMxRef("Window.addEventListener", "addEventListener")}} method of the {{DOMxRef("window")}} object.</p>

<pre class="brush: js">window.addEventListener("devicelight", function (event) {

// Read out the lux value

var luminosity = event.value;

alert(luminosity);

});</pre>

<h2 id="Example">Example:</h2>

<pre class="brush: js">window.addEventListener('devicelight', function(event) {

var bodyBg= document.body.style;

//event.value is the lux value returned by the sensor on the device
if (event.value &lt; 100) {

alert('Hey, you! You are working in a dark environment');

bodyBg.backgroundColor="lightgrey";

} else {

bodyBg.backgroundColor="#fff";

}

});</pre>

<p>This example shows how the API can actually be used in the wild. If your app contains a lot of white in the UI, it is usually beneficial to the user to change the UI to a darker color in a darker environment. The code alerts the user that they are working in a dark environment and then changes the page's background to a darker color. </p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table" style="height: 49px; width: 1000px;">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("AmbientLight", "", "Ambient Light Events")}}</td>
   <td>{{Spec2("AmbientLight")}}</td>
   <td>Initial specification</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DeviceLightEvent")}}</p>

<h2 id="References">References:</h2>

<ul>
 <li><a href="https://hacks.mozilla.org/2013/04/ambient-light-events-and-javascript-detection/">Ambient Light Events and JavaScript detection : Robert Nyman</a></li>
 <li><a href="/en-US/docs/WebAPI/Using_Light_Events">Using light events</a></li>
</ul>
